package domowe.r3.pracownik;

import static org.junit.jupiter.api.Assertions.*;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

class PracownikTest {
	private Pracownik p1;

	@BeforeEach
	void setUp() {
		p1 = new Pracownik(100);
	}

	@Test
	void testPracaWyplata() {
		p1.praca(4);
		p1.praca(6);
		int wynik = p1.wyplata();
		assertEquals(1000, wynik);
	}
	
	@Test
	void testNadgodziny() {
		p1.praca(10);
		p1.praca(12);
		p1.praca(4);
		int wynik = p1.wyplata();
		assertEquals(3200, wynik);
	}
	
	// Dobra praktyka testów jednostkowych: dużo małych testów; każdy aspekt działania opisywać oddzielnym testem
	// W oddzielnych teście napiszemy, że po wypłaceniu pieniędzy licznik się "zeruje"
	@Test
	void testReset() {
		p1.praca(5);
		p1.praca(12);
		p1.wyplata();
		// w tym teście nie interesuje mnie wynik pierwszej wypłaty, bo tym zajmował się inny test
		// interesuje mnie tylko to, czy druga wypłata daje wynik 0
		int kolejnaWyplata = p1.wyplata();
		assertEquals(0, kolejnaWyplata);
	}
	
	@Test
	void testInnaStawka() {
		Pracownik p2 = new Pracownik(150);
		p2.praca(5);
		p2.praca(10);
		int wynik = p2.wyplata();
		assertEquals(2550, wynik);
	}
	
	@Test
	void testPremia() {
		PracownikPremia pp = new PracownikPremia(100);
		pp.praca(10);
		pp.premia(111);
		pp.praca(4);
		pp.premia(333);
		int wynik = pp.wyplata();
		assertEquals(2044, wynik);
		// tutaj wyjątkowo nie piszę kolejnego testu, tylko drugą asercję
		int kolejnaWyplata = pp.wyplata();
		assertEquals(0, kolejnaWyplata);
	}

}
